# -*- coding: utf-8; -*-
#
# oedes - organic electronic device simulator
# Copyright (C) 2017 Marek Zdzislaw Szymanski (marek@marekszymanski.com)
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License, version 3,
# as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

import sys

_prevlen = 0


class TODOWarning(UserWarning):
    pass


import warnings
warnings.simplefilter('ignore', TODOWarning)


def progress(msg):
    global _prevlen
    msg = str(msg)
    if len(msg) < _prevlen:
        pad = ' ' * (_prevlen - len(msg))
    else:
        pad = ''
    _prevlen = len(msg)
    sys.stdout.write('\r' + msg + pad)
    sys.stdout.flush()
